<template>
  <q-page padding>
    <div v-show="loginUrl && authenticated === false">
      <p>Please login to access this page.</p>
      <q-btn
        color="primary"
        label="Login"
        icon="login"
        :href="loginUrl"
      />
    </div>
    <RoomsTable v-show="authenticated === true" />
  </q-page>
</template>

<script lang="ts">

import {
  defineComponent, onMounted, ref,
} from 'vue';
import RoomsTable from 'components/RoomsTable.vue';
import { api } from 'src/boot/axios';
import { useRouter } from 'vue-router';

export default defineComponent({
  name: 'IndexPage',
  components: {
    RoomsTable,
  },
  setup() {
    const router = useRouter();
    const authenticated = ref(false);
    const loginUrl = ref('');
    onMounted(() => {
      authenticated.value = api.isAuthenticated();
      if (!authenticated.value) {
        api.getApiUrl().then((apiUrl) => {
          loginUrl.value = `${apiUrl}/google/redirect`;
        });
      } else {
        const id = sessionStorage.getItem('lastId');
        if (id) {
          sessionStorage.removeItem('lastId');
          router.push({ name: 'room', params: { id } });
        }
      }
    });
    return {
      authenticated,
      loginUrl,
    };
  },
});
</script>
